import javax.management.ObjectName;
import javax.management.Query;
import fr.ippon.groovy.util.WebLoMBean;

def mbs = WebLoMBean.getDomainMBeanServer('t3://localhost:7001', 'weblogic', 'weblogic')

def sourceFilter = javax.management.Query.with {
	match(attr('Name'),value('*@MyFirstDistributedQueue_error'))
}
def sourceMBeanNames = mbs.queryNames(new ObjectName('com.bea:Type=JMSDestinationRuntime,*'), sourceFilter)
def sourceMbeans = sourceMBeanNames.collect { new GroovyMBean(mbs, it) }

sourceMbeans.each { sourceMbean ->
	
	def jmsServerName = sourceMbean.name().getKeyProperty('JMSServerRuntime')

	// recherche de la queue cible sur le mme serveur JMS :
	def targetFilter = javax.management.Query.with {
		match(attr('Name'),value('*@MyFirstDistributedQueue'))
	}
	def targetPattern = "com.bea:Type=JMSDestinationRuntime,JMSServerRuntime=$jmsServerName,*"
	def targetMBeanNames = mbs.queryNames(new ObjectName(targetPattern), targetFilter)
	def targetMBeanName = (targetMBeanNames as List)[0] 
	def targetMbean = new GroovyMBean(mbs, targetMBeanName)
	
	def targetDestinationInfo = targetMbean.DestinationInfo
	
	// dplacement de tous les messages
	def selector = null
	def nbMsgMoved = sourceMbean.moveMessages(selector, targetDestinationInfo)
	println "$nbMsgMoved message(s) moved on server $jmsServerName"

}
